#!/usr/bin/env python3

from typing import Union

import requests
import wx
import io

from Items import Item

default_logo = "https://upload.wikimedia.org/wikipedia/commons/"
default_logo += "thumb/f/fd/Cartoon_Hand_Playing_Multiple_Online_Videos.svg/"
default_logo += "480px-Cartoon_Hand_Playing_Multiple_Online_Videos.svg.png"


class Channel:
    def __init__(self,
                 provider_name: str,
                 feed: str,
                 logo_url: str = default_logo) -> None:
        self.m_provider_name = provider_name
        self.m_feed = feed
        self.m_items: Union[list[Item], None] = None
        res = requests.get(logo_url)
        content = res.content
        content_bytes = io.BytesIO(content)
        self.m_logo = wx.Image(content_bytes,
                               type=wx.BITMAP_TYPE_ANY,
                               index=-1)

    def get_logo_as_bitmap(self) -> wx.Bitmap:
        """
        [TODO:description]

        :rtype wx.Image: [TODO:description]
        """
        return wx.Bitmap(self.m_logo)

    def get_feed(self) -> str:
        return self.m_feed

    def get_items(self) -> Union[list[Item], None]:
        return self.m_items

    def get_provider_name(self) -> str:
        return self.m_provider_name

    def parse_feed(self) -> Union[list[Item], None]:
        pass

    def wait(self) -> bool:
        return False
